diff --git a/src/modules/Extensions/Radio.cpp b/src/modules/Extensions/Radio.cpp
index 6242be97..0e590969 100644
--- a/src/modules/Extensions/Radio.cpp
+++ b/src/modules/Extensions/Radio.cpp
@@ -24,13 +24,13 @@
 #include <Playlist.hpp>
 
 #include <QDesktopServices>
-#include <QJsonDocument>
+#include <QJsonDocument.h>
 #include <QInputDialog>
 #include <QMessageBox>
 #include <QFileDialog>
-#include <QJsonObject>
+#include <QJsonObject.h>
 #include <QScrollBar>
-#include <QJsonArray>
+#include <QJsonArray.h>
 #include <qevent.h>
 #include <QBuffer>
 #include <QTimer>
@@ -111,7 +111,7 @@ Radio::Radio(Module &module) :
     connect(m_dw, SIGNAL(dockVisibilityChanged(bool)), this, SLOT(visibilityChanged(bool)));
     connect(m_radioBrowserModel, SIGNAL(radiosAdded()), m_loadIconsTimer, SLOT(start()));
     connect(m_radioBrowserModel, SIGNAL(searchFinished()), this, SLOT(searchFinished()));
-    connect(m_radioBrowserModel, &RadioBrowserModel::connectionError, this, &Radio::connectionError);
+    connect(m_radioBrowserModel, SIGNAL(connectionError()), this, SLOT(connectionError()));
     connect(m_radioView->verticalScrollBar(), SIGNAL(valueChanged(int)), m_loadIconsTimer, SLOT(start()));
     connect(m_loadIconsTimer, SIGNAL(timeout()), this, SLOT(loadIcons()));
     connect(m_filterEdit, SIGNAL(textEdited(QString)), m_radioBrowserModel, SLOT(setFiltrText(QString)));
@@ -120,16 +120,16 @@ Radio::Radio(Module &module) :
     connect(m_searchComboBox, SIGNAL(activated(int)), this, SLOT(searchData()));
     connect(m_net, SIGNAL(finished(NetworkReply *)), this, SLOT(replyFinished(NetworkReply *)));
 
-    connect(m_addMyRadioStationButton, &QToolButton::clicked, this, &Radio::addMyRadioStationButtonClicked);
-    connect(m_editMyRadioStationButton, &QToolButton::clicked, this, &Radio::editMyRadioStationButtonClicked);
-    connect(m_removeMyRadioStationButton, &QToolButton::clicked, this, &Radio::removeMyRadioStationButtonClicked);
-    connect(m_loadMyRadioStationButton, &QToolButton::clicked, this, &Radio::loadMyRadioStationButtonClicked);
-    connect(m_saveMyRadioStationButton, &QToolButton::clicked, this, &Radio::saveMyRadioStationButtonClicked);
-    connect(m_myRadioListWidget, &QListWidget::itemDoubleClicked, this, &Radio::myRadioListWidgetItemDoubleClicked);
-    connect(m_searchByComboBox, qOverload<int>(&QComboBox::activated), this, &Radio::searchByComboBoxActivated);
-    connect(m_addRadioBrowserStationButton, &QToolButton::clicked, this, &Radio::addRadioBrowserStationButtonClicked);
-    connect(m_radioView, &QTreeView::doubleClicked, this, &Radio::radioViewDoubleClicked);
-    connect(m_radioView, &QTreeView::customContextMenuRequested, this, &Radio::radioViewCustomContextMenuRequested);
+    connect(m_addMyRadioStationButton, SIGNAL(clicked()), this, SLOT(addMyRadioStationButtonClicked()));
+    connect(m_editMyRadioStationButton, SIGNAL(clicked()), this, SLOT(editMyRadioStationButtonClicked()));
+    connect(m_removeMyRadioStationButton, SIGNAL(clicked()), this, SLOT(removeMyRadioStationButtonClicked()));
+    connect(m_loadMyRadioStationButton, SIGNAL(clicked()), this, SLOT(loadMyRadioStationButtonClicked()));
+    connect(m_saveMyRadioStationButton, SIGNAL(clicked()), this, SLOT(saveMyRadioStationButtonClicked()));
+    connect(m_myRadioListWidget, SIGNAL(itemDoubleClicked(QListWidgetItem *)), this, SLOT(myRadioListWidgetItemDoubleClicked(QListWidgetItem *)));
+    connect(m_searchByComboBox, SIGNAL(activated(int)), this, SLOT(searchByComboBoxActivated(int)));
+    connect(m_addRadioBrowserStationButton, SIGNAL(clicked()), this, SLOT(addRadioBrowserStationButtonClicked()));
+    connect(m_radioView, SIGNAL(doubleClicked(QModelIndex)), this, SLOT(radioViewDoubleClicked(QModelIndex)));
+    connect(m_radioView, SIGNAL(customContextMenuRequested(QPoint)), this, SLOT(radioViewCustomContextMenuRequested(QPoint)));
 }
 Radio::~Radio()
 {
@@ -201,8 +201,7 @@ void Radio::ensureTrayMenu()
     {
         auto act = m_menu->addAction(item->text());
         act->setData(item->data(Qt::UserRole));
-        connect(act, &QAction::triggered,
-                this, &Radio::trayActionTriggered);
+        connect(act, SIGNAL(triggered(bool)), this, SLOT(trayActionTriggered(bool)));
     }
 
     m_recreateTrayMenu = false;
@@ -231,21 +230,26 @@ void Radio::searchFinished()
         s += header->sectionSize(i);
     if (s < header->width()) // It's inaccurate comparison
     {
-        header->setSectionResizeMode(0, QHeaderView::Stretch);
+        header->
+#if QT_VERSION >= QT_VERSION_CHECK(5, 0, 0)
+setSectionResizeMode(
+#else
+setResizeMode(
+#endif
+0, QHeaderView::Stretch);
+#if QT_VERSION >= QT_VERSION_CHECK(5, 0, 0)
         if (!m_sectionResizedConn)
         {
-            m_sectionResizedConn = connect(header, &QHeaderView::sectionResized,
-                                           header, [this, header](int logicalIndex, int oldSize, int newSize) {
-                Q_UNUSED(oldSize)
-                Q_UNUSED(newSize)
-
-                if (logicalIndex != 0)
-                    return;
-
-                disconnect(m_sectionResizedConn);
-                header->setSectionResizeMode(0, QHeaderView::Interactive);
-            }, Qt::QueuedConnection);
+            m_sectionResizedConn = connect(header, SIGNAL(sectionResized(int,int,int)),
+                                           this, SLOT(onHeaderSectionResized(int,int,int)),
+                                           Qt::QueuedConnection);
         }
+#else
+        // Qt4: Always connect, we'll handle disconnect manually
+        connect(header, SIGNAL(sectionResized(int,int,int)),
+                this, SLOT(onHeaderSectionResized(int,int,int)),
+                Qt::QueuedConnection);
+#endif
     }
     m_radioView->setEnabled(true);
 }
@@ -287,7 +291,8 @@ void Radio::replyFinished(NetworkReply *reply)
                     if (!data.isObject())
                         continue;
 
-                    const auto name = data["name"].toString();
+                    const QJsonObject dataObj = data.toObject();
+                    const auto name = dataObj["name"].toString();
                     if (name.trimmed().isEmpty())
                         continue;
 
@@ -478,11 +483,13 @@ void Radio::saveMyRadioStationButtonClicked()
     if (idx < 0)
         return;
 
-    const auto suffix = QStringView(filter).mid(idx + 2).chopped(1);
+    // Qt4: No QStringView, use QString methods directly
+    // chopped(1) is equivalent to left(length - 1)
+    const auto suffix = filter.mid(idx + 2, filter.length() - idx - 3);
     if (!filePath.endsWith(suffix, Qt::CaseInsensitive))
         filePath += suffix;
 
-    if (suffix == QStringLiteral(".qmplay2radio"))
+    if (suffix == QString(".qmplay2radio"))
     {
         QSettings(filePath, QSettings::IniFormat).setValue("Radia", getMyRadios());
     }
@@ -659,10 +666,10 @@ void Radio::setSearchInfo(const QStringList &list)
         if (m_searchByComboBox->currentIndex() == Country)
         {
             const auto country = QLocale::countryToString(QLocale::system().country());
-            auto it = std::find_if(list.crbegin(), list.crend(), [&](const QString &str) {
+            auto it = std::find_if(list.constBegin(), list.constEnd(), [&](const QString &str) {
                 return str.contains(country, Qt::CaseInsensitive);
             });
-            const int idx = list.size() - std::distance(list.crbegin(), it) - 1;
+            const int idx = list.size() - std::distance(list.constBegin(), it) - 1;
             if (!country.isEmpty() && idx >= 0 && idx < list.size())
             {
                 m_searchComboBox->setCurrentIndex(idx);
@@ -759,6 +766,33 @@ void Radio::connectionError()
     emit QMPlay2Core.sendMessage(tr("Connection error"), RadioName, 3);
 }
 
+void Radio::onHeaderSectionResized(int logicalIndex, int oldSize, int newSize)
+{
+    Q_UNUSED(oldSize)
+    Q_UNUSED(newSize)
+
+    if (logicalIndex != 0)
+        return;
+
+#if QT_VERSION >= QT_VERSION_CHECK(5, 0, 0)
+    disconnect(m_sectionResizedConn);
+    m_sectionResizedConn = QMetaObject::Connection(); // Reset connection
+#else
+    // Qt4: Disconnect all sectionResized signals from this slot
+    disconnect(m_radioView->header(), SIGNAL(sectionResized(int, int, int)),
+               this, SLOT(onHeaderSectionResized(int, int, int)));
+#endif
+
+    QHeaderView *header = m_radioView->header();
+    header->
+#if QT_VERSION >= QT_VERSION_CHECK(5, 0, 0)
+setSectionResizeMode(
+#else
+setResizeMode(
+#endif
+0, QHeaderView::Interactive);
+}
+
 bool Radio::eventFilter(QObject *watched, QEvent *event)
 {
     if (watched == m_myRadioListWidget)
diff --git a/src/modules/Extensions/Radio.hpp b/src/modules/Extensions/Radio.hpp
index 053ce77b..c731eb35 100644
--- a/src/modules/Extensions/Radio.hpp
+++ b/src/modules/Extensions/Radio.hpp
@@ -20,9 +20,13 @@
 
 #include <QMPlay2Extensions.hpp>
 
+#include <QWidget>
 #include <QPointer>
 #include <QIcon>
 #include <QMap>
+#include <QMenu>
+#include <QTimer>
+#include <QModelIndex>
 
 class QSplitter;
 class QComboBox;
@@ -36,9 +40,8 @@ class RadioBrowserModel;
 class QListWidgetItem;
 class NetworkAccess;
 class NetworkReply;
-class QTimer;
 
-class Radio final : public QWidget, public QMPlay2Extensions
+class Radio : public QWidget, public QMPlay2Extensions
 {
     Q_OBJECT
 
@@ -46,10 +49,10 @@ public:
     Radio(Module &);
     ~Radio();
 
-    DockWidget *getDockWidget() override;
+    DockWidget *getDockWidget();
 
-    QMenu *getTrayMenu() override;
-    void ensureTrayMenu() override;
+    QMenu *getTrayMenu();
+    void ensureTrayMenu();
 
 private slots:
     void visibilityChanged(const bool v);
@@ -66,9 +69,13 @@ private slots:
     void radioBrowserEnqueue();
     void radioBrowserOpenHomePage();
 
+    void onHeaderSectionResized(int logicalIndex, int oldSize, int newSize);
+
 private:
     void setupUi();
 
+private slots:
+    // Qt4: Connected using the old signal/slot syntax
     void addMyRadioStationButtonClicked();
     void editMyRadioStationButtonClicked();
     void removeMyRadioStationButtonClicked();
@@ -82,6 +89,7 @@ private:
     void radioViewDoubleClicked(const QModelIndex &index);
     void radioViewCustomContextMenuRequested(const QPoint &pos);
 
+private:
     QString getFileFilters(bool all) const;
 
     void radioBrowserPlayOrEnqueue(const QModelIndex &index, const QString &param);
@@ -95,14 +103,17 @@ private:
     QStringList getMyRadios() const;
     void loadMyRadios(const QStringList &radios);
 
+private slots:
     void trayActionTriggered(bool checked);
 
+private:
     void play(const QString &url, const QString &name);
 
+private slots:
     void connectionError();
 
 private:
-    bool eventFilter(QObject *watched, QEvent *event) override;
+    bool eventFilter(QObject *watched, QEvent *event);
 
 private:
     QSplitter *m_radioBrowserSplitter;
@@ -129,7 +140,9 @@ private:
     DockWidget *m_dw;
     QMenu *m_menu = nullptr;
 
+#if QT_VERSION >= 0x050000
     QMetaObject::Connection m_sectionResizedConn;
+#endif
 
     QMap<int, QPair<QStringList, QPointer<NetworkReply>>> m_searchInfo;
     RadioBrowserModel *m_radioBrowserModel;
diff --git a/src/modules/Extensions/Radio/RadioBrowserModel.cpp b/src/modules/Extensions/Radio/RadioBrowserModel.cpp
index 1b6deb78..a97c347c 100644
--- a/src/modules/Extensions/Radio/RadioBrowserModel.cpp
+++ b/src/modules/Extensions/Radio/RadioBrowserModel.cpp
@@ -21,9 +21,9 @@
 #include <NetworkAccess.hpp>
 #include <Functions.hpp>
 
-#include <QJsonDocument>
-#include <QJsonObject>
-#include <QJsonArray>
+#include <QJsonDocument.h>
+#include <QJsonObject.h>
+#include <QJsonArray.h>
 #include <QPainter>
 #include <QWidget>
 #include <QUrl>
@@ -62,7 +62,7 @@ RadioBrowserModel::~RadioBrowserModel()
 
 void RadioBrowserModel::clear()
 {
-    for (const std::shared_ptr<Column> &column : std::as_const(m_rows))
+    for (const std::shared_ptr<Column> &column : m_rows)
         delete column->iconReply;
     delete m_replySearch;
 
@@ -88,7 +88,7 @@ void RadioBrowserModel::loadIcons(const int first, const int last)
         if (!column->iconReply && !column->iconUrl.isEmpty())
         {
             column->iconReply = m_net->start(column->iconUrl);
-            for (const std::shared_ptr<Column> &c : std::as_const(m_rows))
+            for (const std::shared_ptr<Column> &c : m_rows)
             {
                 if (c.get() == column)
                     continue;
@@ -296,7 +296,7 @@ void RadioBrowserModel::setFiltrText(const QString &text)
     else
     {
         m_rowsToDisplay.clear();
-        for (const std::shared_ptr<Column> &column : std::as_const(m_rows))
+        for (const std::shared_ptr<Column> &column : m_rows)
         {
             if (column->name.contains(text, Qt::CaseInsensitive))
                 m_rowsToDisplay.append(column);
@@ -323,11 +323,12 @@ void RadioBrowserModel::replyFinished(NetworkReply *reply)
 
             const QPixmap radioIcon = QIcon(":/radio.svgz").pixmap(elementHeight(), elementHeight());
 
-            for (const QJsonValue item : arrayItems)
+            for (const QJsonValue &itemVal : arrayItems)
             {
-                if (!item.isObject())
+                if (!itemVal.isObject())
                     continue;
 
+                const QJsonObject item = itemVal.toObject();
                 QString streamInfo = item["codec"].toString();
                 if (!streamInfo.isEmpty())
                 {
@@ -407,10 +408,13 @@ void RadioBrowserModel::replyFinished(NetworkReply *reply)
                     if (!image.isNull())
                     {
                         const int s = elementHeight();
+#if QT_VERSION >= QT_VERSION_CHECK(5, 0, 0)
                         const qreal dpr = m_widget->devicePixelRatioF();
-
                         column->icon = QPixmap(s * dpr, s * dpr);
                         column->icon.setDevicePixelRatio(dpr);
+#else
+                        column->icon = QPixmap(s, s);
+#endif
                         column->icon.fill(Qt::transparent);
 
                         column->hasIcon = true;
diff --git a/src/modules/Extensions/Radio/RadioBrowserModel.hpp b/src/modules/Extensions/Radio/RadioBrowserModel.hpp
index c5c36986..1b048706 100644
--- a/src/modules/Extensions/Radio/RadioBrowserModel.hpp
+++ b/src/modules/Extensions/Radio/RadioBrowserModel.hpp
@@ -32,7 +32,7 @@ class NetworkAccess;
 class NetworkReply;
 struct Column;
 
-class RadioBrowserModel final : public QAbstractItemModel
+class RadioBrowserModel : public QAbstractItemModel
 {
     Q_OBJECT
 
@@ -54,14 +54,14 @@ public:
     QUrl getHomePageUrl(const QModelIndex &index) const;
     QString getUUID(const QModelIndex &index) const;
 
-    QModelIndex index(int row, int column, const QModelIndex &parent) const override;
-    QModelIndex parent(const QModelIndex &child) const override;
-    int rowCount(const QModelIndex &parent) const override;
-    int columnCount(const QModelIndex &parent) const override;
-    QVariant data(const QModelIndex &index, int role) const override;
-    QVariant headerData(int section, Qt::Orientation orientation, int role = Qt::DisplayRole) const override;
-    Qt::ItemFlags flags(const QModelIndex &index) const override;
-    void sort(int columnIdx, Qt::SortOrder order = Qt::AscendingOrder) override;
+    QModelIndex index(int row, int column, const QModelIndex &parent) const;
+    QModelIndex parent(const QModelIndex &child) const;
+    int rowCount(const QModelIndex &parent) const;
+    int columnCount(const QModelIndex &parent) const;
+    QVariant data(const QModelIndex &index, int role) const;
+    QVariant headerData(int section, Qt::Orientation orientation, int role = Qt::DisplayRole) const;
+    Qt::ItemFlags flags(const QModelIndex &index) const;
+    void sort(int columnIdx, Qt::SortOrder order = Qt::AscendingOrder);
 
 public slots:
     void setFiltrText(const QString &text = QString());
